#Generaul util things

import pygame

class SkipAnim(Exception):
    pass

#Handles events and raises errors, to skip stuff
class Handler:
    def process(self):
        for e in pygame.event.get():
            if e.type == pygame.KEYDOWN and e.key == pygame.K_ESCAPE:
                raise SkipAnim()
            if e.type == pygame.MOUSEBUTTONDOWN:
                raise SkipAnim()

def pause(seconds,handler=None):
    """Pause everything for set number of seconds"""
    c = pygame.time.Clock()
    while seconds>0:
        seconds -= c.tick(60)/1000.0
        if handler:
            handler.process()

def point_in_rect(point,pos,size):
    px,py = point
    dx,dy = pos
    sx,sy = size
    ex,ey = dx+sx,dy+sy
    if px>=dx and px<=ex \
       and py>=dy and py<=ey:
           return True
    return False

class timed_event:
    def __init__(self,function,time):
        self.function = function
        self.time = time

class timer_queue:
    def __init__(self):
        self.queue = []
        self.time = 0.0
    def call_function(self,function):
        function()
    def process(self,dt):
        self.time += dt
        remove = []
        run = []
        for evt in self.queue:
            if evt.time<=self.time:
                run.append(evt.function)
                remove.append(evt)
            else:
                continue
        for e in remove:
            self.queue.remove(e)
        [self.call_function(x) for x in run]
    def add_recurring(self,function,time,seconds):
        """Add an function to the queue that re-
        schedules itself after running"""
        def func():
            self.call_function(function)
            self.add_recurring(function,self.time+seconds,seconds)
        self.insert(func,time)
    def insert(self,function,time=0,next=None):
        if next:
            time = self.time + next
        i = 0
        while i<len(self.queue):
            evt = self.queue[i]
            if evt.time>time:
                self.queue.insert(i,timed_event(function,time))
                return
            i += 1
        self.queue.append(timed_event(function,time))

def playsound(snd,force=True,volume=None):
    c = pygame.mixer.find_channel(force)
    if c:
        if volume != None:
            c.set_volume(volume)
        c.play(snd)
